TermySequence
=============

This is the TermySequence source distribution.

Product home page: https://termysequence.io

Copyright &copy; 2018 TermySequence LLC. Refer to [COPYING.txt](COPYING.txt) for license terms.

## Supported Platforms

  * Linux x64

## Build and Install Instructions

See [Building from Source](https://termysequence.io/doc/build.html) in termy-doc. Note that the canonical source tarballs are found on the [Release Page](https://termysequence.io/releases/). Don't use the autogenerated ones from GitHub.

## Dependencies
### Common

  * cmake 3.9.0+ (build only)
  * gcc/g++ 7.3+ (build only)
  * libuuid (usually part of the base system)

### Server

  * systemd 235+ (optional)
  * libgit2 0.26.0+ (optional, dynamically loaded at runtime)

### Client

  * qt5 5.9.2+ (core, gui, and svg)
  * sqlite 3.8.0+
  * zlib 1.2.5+
  * libfuse 3.1+ or 2.9.7+ (optional)
  * libICU 60.2+ (i18n and uc)
  * ninja (V8 build only)
  * python 2.7 (V8 build only, interpreter must be named "python")
  * jinja2 for python2 (V8 build only)
  * libatomic (V8 build only)
  * libstdc++-static (V8 build only)

### Tests and Utilities

  * cmocka 1.1.1+
  * libxml2

## Repository Layout

  * __vendor__: third party code and content
  * __vendor/termy-emoji__: [termy-emoji](https://github.com/TermySequence/termy-emoji) submodule
  * __vendor/termy-icon-theme__: [termy-icon-theme](https://github.com/TermySequence/termy-icon-theme) submodule
  * __vendor/v8-linux__: [v8-linux](https://github.com/TermySequence/v8-linux) submodule
  * __mux__: server source tree
  * __mux/i18n__: server translation files
  * __mux/scripts__: programs that ship with server (imgcat, etc)
  * __mon__: monitor source tree
  * __src__: client source tree
  * __src/dist__: client plugins, images, and other content
  * __src/i18n__: client translation files
  * __lib__: common protocol library
  * __os__: common os library
  * __doc__: man pages
  * __test__: tests
  * __util__: maintainer tools
