INCLUDE(FindPackageHandleStandardArgs)

PKG_CHECK_MODULES(PC_Systemd QUIET systemd)

FIND_LIBRARY(Systemd_LIBRARY
  NAMES systemd
  PATHS ${PC_Systemd_LIBRARY_DIRS}
)
FIND_PATH(Systemd_INCLUDE_DIR
  NAMES sd-bus.h
  PATHS ${PC_Systemd_INCLUDE_DIRS}
  PATH_SUFFIXES systemd
)

SET(Systemd_VERSION ${PC_Systemd_VERSION})

FIND_PACKAGE_HANDLE_STANDARD_ARGS(Systemd
  REQUIRED_VARS Systemd_LIBRARY Systemd_INCLUDE_DIR
  VERSION_VAR Systemd_VERSION
)

IF (Systemd_FOUND)
  ADD_LIBRARY(l::Systemd UNKNOWN IMPORTED)
  SET_TARGET_PROPERTIES(l::Systemd PROPERTIES
    IMPORTED_LOCATION "${Systemd_LIBRARY}"
    INTERFACE_COMPILE_OPTIONS "${PC_Systemd_CFLAGS_OTHER}"
    INTERFACE_INCLUDE_DIRECTORIES "${Systemd_INCLUDE_DIR}"
  )
ENDIF()
